<solidify-base-action-dialog [titleToTranslate]="'deposit.file.modal.title.main' | translate">
  <h2>{{labelTranslateEnum.metadata | translate}}</h2>
  <form [formGroup]="form">
    <mat-form-field *ngIf="getFormControl(formDefinition.subDirectory) as fd"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.subDirectory | translate}}</mat-label>
      <input [formControl]="fd"
             id="deposit-upload-subdirectory"
             matInput
      >
    </mat-form-field>
    <mat-form-field *ngIf="getFormControl(formDefinition.dataCategory) as fd"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.dataCategory | translate}}</mat-label>
      <mat-select [disabled]="data?.dataCategoryEnum | isNotNullNorUndefined"
                  [solidifyDataTest]="dataTestEnum.depositDataCategory"
                  [formControl]="fd"
      >
        <mat-option *ngFor="let dataCategory of (listDataCategoriesObs | async)"
                    [value]="dataCategory"
                    solidifyTooltipOnEllipsis
        >
          {{enumUtil.getLabel(enumsDataFile.DataCategoryEnumTranslate, dataCategory) | translate}}
        </mat-option>
      </mat-select>
    </mat-form-field>

    <mat-form-field *ngIf="getFormControl(formDefinition.dataType) as fd"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.dataType | translate}}</mat-label>
      <mat-select [disabled]="(data?.dataCategoryEnum | isNotNullNorUndefined) && (data?.dataTypeEnum | isNotNullNorUndefined)"
                  [solidifyDataTest]="dataTestEnum.depositDataType"
                  [formControl]="fd"
      >
        <mat-option *ngFor="let dataType of (listDataTypesObs | async); trackBy: trackByDataType"
                    [value]="dataType"
                    [disabled]="(data.enableValuesFromEnum | isNotNullNorUndefined) && !data.enableValuesFromEnum?.includes(dataType)"
                    solidifyTooltipOnEllipsis
        >
          {{enumUtil.getLabel(enumsDataFile.DataTypeEnumTranslate, dataType) | translate}}
        </mat-option>
      </mat-select>
    </mat-form-field>

    <ng-template [ngIf]="getFormControl(formDefinition.dataType).value === dataTypeEnum.CUSTOM_METADATA">
      <solidify-searchable-single-select *ngIf="getFormControl(formDefinition.metadataType) as fd"
                                         [formControl]="fd"
                                         [labelCallback]="metadataTypeLabelCallback"
                                         [labelKey]="'name'"
                                         [placeholder]="labelTranslateEnum.metadataType | translate"
                                         [required]="formValidationHelper.hasRequiredField(fd)"
                                         [resourceNameSpace]="depositDataFileMetadataTypeActionNameSpace"
                                         [state]="depositDataFileMetadataTypeState"
                                         [valueKey]="'resId'"
                                         solidifyValidation
      >
      </solidify-searchable-single-select>
    </ng-template>
  </form>

  <div solidifyFileDropZone
       (fileDropped)="dropFile($event)"
  >
    <div class="file-upload-title-wrapper">
      <h2>{{labelTranslateEnum.filesToUpload | translate}}</h2>
      <div *ngIf="isChecksumComputing"
           class="checksum-generated-indicator"
      >{{labelTranslateEnum.checksums | translate}} :
        <span class="calculating">{{labelTranslateEnum.calculating | translate}}</span>
      </div>
    </div>

    <mat-accordion [multi]="true">
      <mat-expansion-panel *ngFor="let file of filesToUpload; let i = index"
                           [expanded]="i === 0"
                           [class.in-error]="formArray.at(i).invalid && formValidationHelper.getFormControl(asFormGroup(formArray.at(i)),
                         formDefinitionChecksum.checksumGeneratedIsLoadingCounter)?.value === 0"
                           class="expansion-panel"
      >
        <mat-expansion-panel-header>
          <mat-panel-title class="file-title-header">
          <span class="file-name"
                [class.is-in-error]="file.isInError"
          >{{file.file.name}}</span>
            <button (click)="delete(file.file, i)"
                    (onEnter)="delete(file.file, i)"
                    [matTooltipPosition]="'left'"
                    [matTooltip]="labelTranslateEnum.delete | translate"
                    class="trash"
                    mat-icon-button
                    solidifyShortCuts
                    type="button"
            >
              <solidify-icon [iconName]="iconNameEnum.delete"></solidify-icon>
            </button>
          </mat-panel-title>
        </mat-expansion-panel-header>
        <ul>
          <li>
            <span class="label">{{labelTranslateEnum.type | translate}}</span>
            <span class="value">{{file.file.type}}</span>
          </li>
          <li>
            <span class="label">{{labelTranslateEnum.size | translate}}</span>
            <span class="value">{{file.file.size | filesize}}</span>
          </li>
          <li>
            <span class="label">{{labelTranslateEnum.updated | translate}}</span>
            <span class="value">{{getDate(file.file.lastModified) | date}}</span>
          </li>
        </ul>

        <ng-template [ngIf]="checksumUsed | isNonEmptyArray">
          <ng-container *ngIf="formArray.at(i) as formGroupUntyped">
            <ng-container *ngIf="asFormGroup(formGroupUntyped) as formGroup">
              <div class="checksum-header-wrapper">
                <mat-checkbox *ngIf="formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.isChecksumUser) as fd"
                              [formControl]="fd"
                              color="primary"
                              class="provide-checksums"
                >
                  {{labelTranslateEnum.provideChecksums | translate}}
                </mat-checkbox>
                <div class="checksum-generated-indicator">{{labelTranslateEnum.checksums | translate}} :
                  <span *ngIf="formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumGeneratedIsLoadingCounter)?.value > 0; else
              noPending"
                        class="calculating"
                  >
                {{labelTranslateEnum.calculating | translate}}
              </span>
                  <ng-template #noPending>
                    <solidify-icon *ngIf="(formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.isChecksumGenerated)?.value | isTrue); else
                unableToGenerate"
                                   [iconName]="iconNameEnum.check"
                                   [matTooltip]="labelTranslateEnum.checksumsComputedByThePortal | translate"
                                   class="valid size-18"
                    ></solidify-icon>
                    <ng-template #unableToGenerate>
                      <solidify-icon [iconName]="iconNameEnum.warning"
                                     [matTooltip]="labelTranslateEnum.unableToComputeChecksumsWithPortalBecauseSizeExeedLimitOfX | translate:{limit:
                                 LIMIT_CHECKSUM_COMPUTE_IN_MEGABYTE}"
                                     class="warning size-18"
                      ></solidify-icon>
                    </ng-template>
                  </ng-template>
                </div>
              </div>

              <div *ngIf="formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.isChecksumUser)?.value | isTrue"
                   class="user-checksums"
              >
                <mat-form-field *ngIf="formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumUserMd5) as fd"
                                [appearance]="appearanceInputMaterial"
                                solidifyTooltipOnEllipsis
                >
                  <mat-label>MD5</mat-label>
                  <input [formControl]="fd"
                         [required]="formValidationHelper.hasRequiredField(fd)"
                         [maxLength]="CHECKSUM_LENGTH_MD5"
                         matInput
                  >
                  <mat-error *ngIf="fd.errors?.mismatch && formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumGeneratedMd5).value"
                             solidifyTooltipOnEllipsis
                  >
                    {{
                          labelTranslateEnum.checksumInconsistentWithExpectedValueX | translate : {
                              value: formValidationHelper.getFormControl(formGroup,
                                  formDefinitionChecksum.checksumGeneratedMd5).value
                          }
                    }}
                  </mat-error>
                  <mat-error *ngIf="fd.errors?.minlength || fd.errors?.maxlength"
                             solidifyTooltipOnEllipsis
                  >{{labelTranslateEnum.theChecksumFormatIsNotTheExpectedOne | translate}}
                  </mat-error>
                </mat-form-field>

                <mat-form-field *ngIf="formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumUserSha1) as fd"
                                [appearance]="appearanceInputMaterial"
                                solidifyTooltipOnEllipsis
                >
                  <mat-label>SHA-1</mat-label>
                  <input [formControl]="fd"
                         [required]="formValidationHelper.hasRequiredField(fd)"
                         [maxLength]="CHECKSUM_LENGTH_SHA1"
                         matInput
                  >
                  <mat-error *ngIf="fd.errors?.mismatch && formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumGeneratedSha1).value"
                             solidifyTooltipOnEllipsis
                  >
                    {{
                          labelTranslateEnum.checksumInconsistentWithExpectedValueX | translate : {
                              value: formValidationHelper.getFormControl(formGroup,
                                  formDefinitionChecksum.checksumGeneratedSha1).value
                          }
                    }}
                  </mat-error>
                  <mat-error *ngIf="fd.errors?.minlength || fd.errors?.maxlength"
                             solidifyTooltipOnEllipsis
                  >{{labelTranslateEnum.theChecksumFormatIsNotTheExpectedOne | translate}}
                  </mat-error>
                </mat-form-field>

                <mat-form-field *ngIf="formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumUserSha256) as fd"
                                [appearance]="appearanceInputMaterial"
                                solidifyTooltipOnEllipsis
                >
                  <mat-label>SHA-256</mat-label>
                  <input [formControl]="fd"
                         [required]="formValidationHelper.hasRequiredField(fd)"
                         [maxLength]="CHECKSUM_LENGTH_SHA256"
                         matInput
                  >
                  <mat-error *ngIf="fd.errors?.mismatch && formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumGeneratedSha256).value"
                             solidifyTooltipOnEllipsis
                  >
                    {{
                          labelTranslateEnum.checksumInconsistentWithExpectedValueX | translate : {
                              value: formValidationHelper.getFormControl(formGroup,
                                  formDefinitionChecksum.checksumGeneratedSha256).value
                          }
                    }}
                  </mat-error>
                  <mat-error *ngIf="fd.errors?.minlength || fd.errors?.maxlength"
                             solidifyTooltipOnEllipsis
                  >{{labelTranslateEnum.theChecksumFormatIsNotTheExpectedOne | translate}}
                  </mat-error>
                </mat-form-field>

                <mat-form-field *ngIf="formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumUserSha512) as fd"
                                [appearance]="appearanceInputMaterial"
                                solidifyTooltipOnEllipsis
                >
                  <mat-label>SHA-512</mat-label>
                  <input [formControl]="fd"
                         [required]="formValidationHelper.hasRequiredField(fd)"
                         [maxLength]="CHECKSUM_LENGTH_SHA512"
                         matInput
                  >
                  <mat-error *ngIf="fd.errors?.mismatch && formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumGeneratedSha512).value"
                             solidifyTooltipOnEllipsis
                  >
                    {{
                          labelTranslateEnum.checksumInconsistentWithExpectedValueX | translate : {
                              value: formValidationHelper.getFormControl(formGroup,
                                  formDefinitionChecksum.checksumGeneratedSha512).value
                          }
                    }}
                  </mat-error>
                  <mat-error *ngIf="fd.errors?.minlength || fd.errors?.maxlength"
                             solidifyTooltipOnEllipsis
                  >{{labelTranslateEnum.theChecksumFormatIsNotTheExpectedOne | translate}}
                  </mat-error>
                </mat-form-field>

                <mat-form-field *ngIf="formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumUserCrc32) as fd"
                                [appearance]="appearanceInputMaterial"
                                solidifyTooltipOnEllipsis
                >
                  <mat-label>CRC32</mat-label>
                  <input [formControl]="fd"
                         [required]="formValidationHelper.hasRequiredField(fd)"
                         [maxLength]="CHECKSUM_LENGTH_CRC32"
                         matInput
                  >
                  <mat-error *ngIf="fd.errors?.mismatch && formValidationHelper.getFormControl(formGroup, formDefinitionChecksum.checksumGeneratedCrc32).value"
                             solidifyTooltipOnEllipsis
                  >
                    {{
                          labelTranslateEnum.checksumInconsistentWithExpectedValueX | translate : {
                              value: formValidationHelper.getFormControl(formGroup,
                                  formDefinitionChecksum.checksumGeneratedCrc32).value
                          }
                    }}
                  </mat-error>
                  <mat-error *ngIf="fd.errors?.minlength || fd.errors?.maxlength"
                             solidifyTooltipOnEllipsis
                  >{{labelTranslateEnum.theChecksumFormatIsNotTheExpectedOne | translate}}
                  </mat-error>
                </mat-form-field>
              </div>
            </ng-container>
          </ng-container>
        </ng-template>
      </mat-expansion-panel>
    </mat-accordion>

    <div *ngIf="isCurrentFileNameInError()"
         class="error-message"
    >{{labelTranslateEnum.listInvalidCharacter | translate}}
    </div>

    <div class="button-add-files-wrapper">
      <button (click)="fileInput.click()"
              solidifyAlternativeButton
      >
        {{labelTranslateEnum.add | translate}}
        <input #fileInput
               [name]="files"
               (change)="onFileChange($any($event))"
               class="hide"
               id="file-upload"
               [multiple]="(data.onlyOneFile | isNullOrUndefined) || (data.onlyOneFile | isFalse)"
               type="file"
        >
      </button>
    </div>
  </div>
</solidify-base-action-dialog>
<div class="footer"
     mat-dialog-actions
>
  <button [mat-dialog-close]=""
          [solidifyAutoFocus]="true"
          mat-button
          color="primary"
  >{{labelTranslateEnum.close | translate}}
  </button>
  <button (click)="onSubmit()"
          [disabled]="form.invalid || filesToUpload.length === 0 || isCurrentFileNameInError() || formArray.invalid"
          color="primary"
          id="deposit-upload-confirm"
          mat-flat-button
  >{{labelTranslateEnum.confirm | translate}}
  </button>
</div>

